package scrabble;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

/**
 * Board for the Scribble game Just keep track of the positioned Tiles (i.e.
 * don't waste a lot of space using Tile[][] or similar)
 *
 * @author hajo
 */
public class Board {

    // The positions for tiles 
    private final List<Position> positions = new ArrayList<>();
    private final int rows;
    private final int cols;

    public Board(int rows, int cols) {
        this.rows = rows;
        this.cols = cols;
    }

    public boolean add(Position p) {
        // NOTE: This depends on equals()-method!
        if (!positions.contains(p)) {
            return positions.add(p);
        } else {
            return false;
        }
    }

    public void removeWord(Set<Position> word) {
        for (Position p : word) {
            positions.remove(p);
        }
    }

    public int getMaxRow() {
        return rows;
    }

    public int getMaxCol() {
        return cols;
    }

    @Override
    public String toString() {
        StringBuilder b = new StringBuilder();
        String[][] board = new String[rows][cols];
        for (Position p : positions) {
            board[p.getRow()][p.getCol()] = p.getTile().getGlypth();
        }
        for (int r = 0; r < rows; r++) {
            for (int c = 0; c < cols; c++) {
                b.append(board[r][c]).append(",");
            }
            b.append("\n");
        }
        return b.toString();
    }
}
