package scrabble;

import java.util.Arrays;
import java.util.List;

/**
 * A Scribble player
 *
 * @author hajo
 */
public class Player {

    private final Holder holder = new Holder(ScrabbleOptions.getMaxHolder());
    private final String name;
    private final TileBag bag;  // Shared by all
    private int points;

    public Player(String name, TileBag bag) {
        this.name = name;
        this.bag = bag;
        for (int i = 0; i < holder.size(); i++) {
            Tile t = bag.get();
            holder.add(t);
        }
    }

    public void addPoints(int points) {
        this.points += points;
    }

    public Tile pickTileFromHolder(int index) {
        return holder.remove(index);
    }

    public void pickNewTilesFromBag() {
        for( int i = 0 ; i < holder.actualSize() ; i++){
            holder.add(bag.get());
        }
    }

    public void putBackTile(Tile tile) {
            holder.add(tile);
    }

    public List<Tile> tiles() {
        return holder.getTiles();
    }

    public String getName() {
        return name;
    }

    public int getPoints() {
        return points;
    }

    @Override
    public String toString() {
        return "(" + name + ":" + holder.toString() + ")";
    }
}
