package scrabble;

import java.util.ArrayList;
import java.util.List;

/**
 * Representing the Scrabble game. Much of the game logic here
 *
 * @author hajo
 *
 */
public class Scrabble {

    //private final WordBook book; //TODO
    private final Board board;
    private final List<Player> players = new ArrayList<>();
    private Player actual;

    public Scrabble(List<String> playerNames, TileBag bag, int rows, int cols) {
        for (String name : playerNames) {
            this.players.add(new Player(name, bag));
        }
        this.board = new Board(rows, cols);
    }

    public void start() {
        for( Player p: players){
            p.pickNewTilesFromBag();
        }
        actual = players.get(0); // TODO Should be random
    }

    public boolean putTiles(List<Position> positions) {
        if (check(positions)) {
            for( Position p : positions)
            board.add(p);
            return true;
        } else {
            return false;
        }

    }

    public void nextPlayer() {
        actual = players.get((players.indexOf(actual) + 1)
                % ScrabbleOptions.getMaxPlayers());
    }
    
     // Used by GUI
    public List<Player> players() {
        return players;
    }

    // Used by GUI
    public Player getActualPlayer() {
        return actual;
    }

    // Used by GUI
    public Board getBoard() {
        return board;
    }

    // TODO 
    private boolean check(List<Position> positions) {
        return true;
    }

    @Override
    public String toString() {
        return board.toString();
    }
    
    
}
